# $Id: ppp.py 290 2006-01-22 02:43:28Z dugsong $

"""Point-to-Point Protocol."""

import struct
import dpkt, ip

# XXX - finish later

# http://www.iana.org/assignments/ppp-numbers
PPP_IP	= 0x21	# Internet Protocol

# Protocol field compression
PFC_BIT	= 0x01

class PPP(dpkt.Packet):
    __hdr__ = (
        ('p', 'B', PPP_IP),
        )
    _protosw = {
        PPP_IP:ip.IP,
        }
    def unpack(self, buf):
        dpkt.Packet.unpack(self, buf)
        if self.p & PFC_BIT == 0:
            self.p = struct.unpack('>H', buf)
            self.data = self.data[1:]
        try:
            self.data = self._protosw[self.p](self.data)
            setattr(self, self.data.__class__.__name__.lower(), self.data)
        except (KeyError, dpkt.UnpackError):
            pass
